<?php

namespace Drupal\give;

use Drupal\views\EntityViewsData;

/**
 * Provides data to integrate donations with Views.
 */
class DonationViewsData extends EntityViewsData {

  /**
   * {@inheritdoc}
   */
  public function getViewsData() {
    $data = parent::getViewsData();

    $data['give_donation']['amount'] = [
      'title' => $this->t('Amount'),
      'help' => $this->t('The formatted value of the donation'),
      'field' => [
        'id' => 'give_amount',
      ],
    ];
    // this is like the entity reference but falls back to the name field if the
    // donor wasn't a member.
    $data['give_donation']['uid']['field'] = [
      'id' => 'give_name',
    ];
    $data['give_donation']['method']['filter'] = [
      'id' => 'in_operator',
      'options callback' => 'payment_method_names'
    ];
    $data['give_donation']['recurring']['field'] = [
      'id' => 'give_recurrence',
    ];

    return $data;
  }

}
