<?php

namespace Drupal\give\Plugin\views\field;

use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;
use Drupal\user\Entity\User;

/**
 * Field handler to provide the label of a give form.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("give_name")
 */
class GiveName extends FieldPluginBase {

  /**
   * Render form label.
   */
  protected function renderName($form_id, $values) {
    if ($form_id !== NULL && $form_id !== '') {
      $type = $this->formStorage->load($form_id);
      return $type ? $this->sanitizeValue($type->label()) : '';
    }
    return $this->sanitizeValue($form_id);
  }

  /**
   * {@inheritdoc}
   */
  public function render(ResultRow $values) {
    $value = $this->getValue($values);
    if ($value) {
      return $values->_entity->getOwner()->getDisplayName();
    }
    else {
      return $values->name;
    }
  }

}
